#!/bin/sh
#
# Script to start server.
#
# Usage: pure-server
#
# Environment Variable Prequisites
#
#   JAVA_HOME       Must point at your Java JRE or JDK installation.
#   JAVA_OPTS       (Optional) Java runtime options used.


# Java options
JAVA_OPTS="-Xms64m -Xmx512m $JAVA_OPTS"

# Java main class
MAIN_CLASS=com.pureload.net.websocket.server.WebSocketServer

# increase number of file descriptors (must be root to set this)
ulimit -n 32768

#
# OS specific support.
#
cygwin=false;
darwin=false;
case "`uname`" in
  CYGWIN*) cygwin=true ;;
  Darwin*) darwin=true
           if [ -z "$JAVA_HOME" ] ; then
             JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Home
           fi
           ;;
esac

#
# Get the PURESERVER_HOME variable
#
if [ -z "$PURESERVER_HOME" ] ; then
  # use the location of this script to infer $PURESERVER_HOME
  whoami=`basename $0`
  whereami=`echo $0 | sed -e "s#^[^/]#\`pwd\`/&#"`
  whereami=`dirname $whereami`

  # Resolve any symlinks of the now absolute path, $whereami
  realpath_listing=`ls -l $whereami/$whoami`
  case "$realpath_listing" in
    *-\>\ /*)
      realpath=`echo $realpath_listing | sed -e "s#^.*-> ##"`
      ;;
    *-\>*)
      realpath=`echo $realpath_listing | sed -e "s#^.*-> #$whereami/#"`
      ;;
    *)
      realpath=$whereami/$whoami
      ;;
  esac
  PURESERVER_HOME=`dirname "$realpath"`/..
fi

#
# Get the Java command
#
if [ -z "$JAVACMD" ] ; then
  if [ -n "$JAVA_HOME"  ] ; then
    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
      # IBM's JDK on AIX uses strange locations for the executables
      JAVACMD="$JAVA_HOME/jre/sh/java"
    else
      JAVACMD="$JAVA_HOME/bin/java"
    fi
  else
    JAVACMD=`which java 2> /dev/null `
    if [ -z "$JAVACMD" ] ; then
        JAVACMD=java
    fi
  fi
fi

if [ ! -x "$JAVACMD" ] ; then
  echo "Error: JAVA_HOME is not defined correctly."
  echo "  We cannot execute $JAVACMD"
  exit 1
fi


#
# Get the path separator
#
if [ "$cygwin" = "true" ] ; then
  S=';'
else
  S=':'
fi

#
# Build classpath
#

for i in $PURESERVER_HOME/lib/*.jar; do
  if [ "$cygwin" = "true" ] ; then
    LIB=`cygpath -w $i`
  else
    LIB=$i
  fi

  PURESERVER_CLASSPATH=$PURESERVER_CLASSPATH$S$LIB
done
if [ "$cygwin" = "true" ] ; then
    PURESERVER_CLASSPATH=$PURESERVER_CLASSPATH$S`cygpath -w $PURESERVER_HOME/conf`
else
    PURESERVER_CLASSPATH=$PURESERVER_CLASSPATH$S$PURESERVER_HOME/conf
fi


#
# Execute command
#
CURR_DIR=`pwd`
cd $PURESERVER_HOME
"$JAVACMD" $JAVA_OPTS -classpath "$PURESERVER_CLASSPATH" $MAIN_CLASS $@
RESULT=$?
cd $CURR_DIR
exit $RESULT
